/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... uvod do OOP
   Trida Vektor
*/

#include <iostream>
using namespace std;

class Vektor
{
//private:
	float x;
	float y;
	const int n;

public:
	// konstruktor se dvema parametry:
	Vektor(float x, float y) : x(x), y(y), n(2)
	{
		//this->x = x;
		//this->y = y;
	}
	// konstruktor s jednim parametrem:
	Vektor(float x = 0) : n(2)
	{
		this->x = x;
		this->y = 0;
	}
	/*
	// konstruktor se dvema parametry (alternativne):
	Vektor(float x=0, float y=0)
	{
		this->x = x;
		this->y = y;
	}
	*/
	/*
	// konstruktor se dvema parametry (alternativne):
	Vektor(float x, float y)
	{
		this->x = x;
		this->y = y;
	}
	// konstruktor bez parametru (alternativne):
	Vektor()
	{
		this->x = 0;
		this->y = 0;
	}*/

	//void setX(float x)
	void nastavX(float x)
	{
		this->x = x;
	}
	//void setY(float y)
	void nastavY(float y)
	{
		this->y = y;
	}
	//float getX()
	float vratX()
	{
		return x;
	}
	//float getY()
	float vratY()
	{
		return y;
	}
	void vypis()
	{
		cout << x << " " << y << endl;
	}
	// spratelena funkce (nejedna se o metodu tridy):
	friend float delka(const Vektor &v)
	{
		return sqrt(v.x*v.x + v.y*v.y);
	}
	float delka() const
	{
		return sqrt(x*x + y*y);
	}
};

int mainVektor()
{
	// volani konstruktoru (pro lokalni nebo globalni instanci):
	Vektor v(1, 2);
	Vektor w(3);
	Vektor z;

	v.vypis();
	w.vypis();
	z.vypis();

	v.nastavX(5);
	v.nastavY(4);
	v.vypis();

	cout << v.vratX() << " " << v.vratY() << endl;
	cout << delka(v) << endl;
	cout << v.delka() << endl;

	// volani konstruktoru pro dynamickou instanci:
	// Vektor *uz = new Vektor;
	// Vektor *uz = new Vektor();
	// Vektor *uz = new Vektor(1);
	Vektor *uz = new Vektor(4, -3);
	uz->vypis();
	delete uz;

	
	return 0;
}

