/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... objekty ... Zlomek
*/

#include "Zlomek.h"
#include <iostream>
using namespace std;

/* Funkce vrati nejvetsiho spolecneho delitele cisel x a y.
*/
int nsd(int x, int y)
{
	if (x == 0)
		return y;
	if (y == 0)
		return x;

	if (x < 0)
		x = -x;
	if (y < 0)
		y = -y;

	while (x != y)
	{
		if (x > y)
			x -= y;
		else // if (y > x)
			y -= x;
	}
	return x;
}

/* Metoda prevede zlomek do zakladniho tvaru.
*/
void Zlomek::zakladniTvar()
{
	if (jmenovatel == 0)
		throw 1;

	int x = nsd(citatel, jmenovatel);
	citatel /= x;
	jmenovatel /= x;

	if (jmenovatel < 0)
	{
		citatel = -citatel;
		jmenovatel = -jmenovatel;
	}
}

/* Konstruktor Zlomku */
Zlomek::Zlomek(int cit, int jm) : citatel(cit), jmenovatel(jm)
{
	zakladniTvar();
}

/* Destruktor Zlomku */
Zlomek::~Zlomek()
{
}

/* Setter citatele */
void Zlomek::nastavCitatele(int hodnota)
{
	citatel = hodnota;
	zakladniTvar();
}

/* Setter jmenovatele */
void Zlomek::nastavJmenovatele(int hodnota)
{
	this->jmenovatel = hodnota;
	this->zakladniTvar();
}

/* Getter citatele */
int Zlomek::vratJmenovatele() const
{
	return jmenovatel;
}

/* Getter jmenovatele */
int Zlomek::vratCitatele()  const
{
	return citatel;
}

/* Funkce vynasobi dva zlomky a vrati vysledek. */
Zlomek vynasob(const Zlomek &x, const Zlomek &y)
//Zlomek vynasob(Zlomek &x, Zlomek &y)
{
	int citatel = x.vratCitatele() * y.vratCitatele();
	int jmenovatel = x.vratJmenovatele() * y.vratJmenovatele();
	
	Zlomek z(citatel, jmenovatel);
	return z;
	
	// return Zlomek(citatel, jmenovatel);
}

Zlomek secti(const Zlomek &x, const Zlomek &y)
//Zlomek secti(Zlomek &x, Zlomek &y)
{
	int citatel = x.vratCitatele() * y.vratJmenovatele() + y.vratCitatele() * x.vratJmenovatele();
	int jmenovatel = x.vratJmenovatele() * y.vratJmenovatele();

	return Zlomek(citatel, jmenovatel);
}

Zlomek vydel(const Zlomek &x, const Zlomek &y)
{
	int citatel = x.vratCitatele() * y.vratJmenovatele();
	int jmenovatel = x.vratJmenovatele() * y.vratCitatele();

	return Zlomek(citatel, jmenovatel);
}

Zlomek odecti(const Zlomek &x, const Zlomek &y)
{
	int citatel = x.vratCitatele() * y.vratJmenovatele() - y.vratCitatele() * x.vratJmenovatele();
	int jmenovatel = x.vratJmenovatele() * y.vratJmenovatele();

	return Zlomek(citatel, jmenovatel);
}

/* Vypis Zlomku na konzoli. */
void Zlomek::vypis() const
{
	cout << citatel << " / " << jmenovatel << endl;
}

void Zlomek::pricti(const Zlomek &x) 
{
	 citatel = (citatel * x.vratJmenovatele() + jmenovatel * x.vratCitatele());
	 nastavJmenovatele(x.vratJmenovatele() * jmenovatel);

	// citatel = (citatel * x.jmenovatel + jmenovatel * x.citatel);
	// nastavJmenovatele(x.jmenovatel * jmenovatel);
}

void Zlomek::prinasob(const Zlomek &x)
{
	// citatel = (citatel * x.vratCitatele());
	// nastavJmenovatele(x.vratJmenovatele() * jmenovatel);

	citatel = (citatel * x.citatel);
	nastavJmenovatele(x.jmenovatel * jmenovatel);
}
void Zlomek::odecti(const Zlomek &x)
{
	// citatel = (citatel * x.vratJmenovatele() - jmenovatel * x.vratCitatele());
	// nastavJmenovatel(x.vratJmenovatele() * jmenovatel);

	citatel = (citatel * x.jmenovatel - jmenovatel * x.citatel);
	nastavJmenovatele(x.jmenovatel * jmenovatel);
}
void Zlomek::vydel(const Zlomek &x)
{
	// citatel = (citatel * x.vratJmenvatele());
	// nastavJmenovatel(x.vratCitatele() * jmenovatel);

	citatel = (citatel * x.jmenovatel);
	nastavJmenovatele(x.citatel * jmenovatel);
}

int mainZlomek()
{
	Zlomek x1(14,4);
	Zlomek x2(6, -8);

	Zlomek x3 = vynasob(x1, x2); 
	x1.vypis();
	x2.vypis();
	x3.vypis();

	x3.pricti(x1);
	x3.vypis();

	// defaultni kopirovaci konstruktor:
	Zlomek x4 = x3;
	x4.vypis();
	// operator prirazeni:
	x4 = x1;
	x4.vypis();
	x3.vypis();

	return 0;
}
